;(function($){
    if (!$.joomlart) $.joomlart = {};

    $.joomlart.socialLocker = {
        container: null,
        settings: {},
        sdk: {
            facebook: {
                src: '//connect.facebook.net/en_US/all.js#xfbml=1',
                id: 'facebook-jssdk',
                isLoaded: function() {
                    return ($.type(window.FB) == 'object');
                },
                createButton: function(container, settings) {
                    var buttons = container.find('.ja-fb-like');
                    if(buttons.length) {
                        if(!this.isLoaded() && settings.loadSdk) {
                            var src = this.src;
                            if($.type(settings.language) != 'null') {
                                src = src.replace('en_US', settings.language);
                            }
                            if($.type(settings.facebook_appid) != 'undefined') {
                                src += '&appId=' + settings.facebook_appid;
                            }
                            //add script param
                            $.joomlart.socialLocker.loadScript(this.id, src);

                            var config = {
                                appId      : settings.facebook_appid, // App ID
                                status     : true, // check login status
                                cookie     : true, // enable cookies to allow the server to access the session
                                xfbml      : true  // parse XFBML
                            };
                            window.fbAsyncInit = function() {
                                FB.init(config);
                                // Additional initialization code here
                            };
                        }

                        (function(d, b, s){
                            var r = function() {
                                if(d.isLoaded()) {
                                    d._renderButton(b, s);
                                } else {
                                    setTimeout(function() {
                                        r();
                                    }, 500);
                                }
                            };
                            r();
                        })(this, buttons[0], settings);

                    }
                },
                _renderButton: function(btn, settings){
                    var d = $(btn);
                    d.addClass('fb-like');
                    window.FB.XFBML.parse(btn);

                    window.FB.Event.subscribe("xfbml.render", function () {
                        $(document).trigger("fb-render", [{mid: settings.moduleid}]);
                    });
                    window.FB.Event.subscribe("edge.create", function (url, element) {
                        var p = $(element).parent();
                        var mid = p.data('mid');
                        $(document).trigger("fb-like", [{url:url, element:element, mid: mid}]);
                    });
                    window.FB.Event.subscribe("edge.remove", function (url, element) {
                        var p = $(element).parent();
                        var mid = p.data('mid');
                        $(document).trigger("fb-dislike", [{url:url, element:element, mid: mid}]);
                    });
                }
            },
            twitter: {
                src: '//platform.twitter.com/widgets.js',
                id: 'twitter-wjs',
                isLoaded: function() {
                    if ($.type(window.twttr) != 'undefined') {
                        return ($.type(window.twttr.widgets) != 'undefined');
                    }
                    return false;
                },
                createButton: function(container, settings) {
                    var buttons = container.find('.ja-twitter-share-button');
                    if(buttons.length) {
                        if(!this.isLoaded() && settings.loadSdk) {
                            $.joomlart.socialLocker.loadScript(this.id, this.src);
                        }
                        var tid = Math.floor(Math.random() * settings.tweets.length);
                        var tweet = settings.tweets[tid];
                        $(buttons[0]).addClass('twitter-share-button').attr('data-text', tweet);

                        (function(d, b, s){
                            var r = function() {
                                if(d.isLoaded()) {
                                    d._renderButton(b, s);
                                } else {
                                    setTimeout(function() {
                                        r();
                                    }, 500);
                                }
                            };
                            r();
                        })(this, buttons[0], settings);
                    }
                },
                _renderButton: function(btn, settings){
                    $(document).trigger("tw-render", [{mid: settings.moduleid}]);

                    window.twttr.events.bind("tweet", function (event) {
                        var p = $(event.target).parent();
                        var mid = p.data('mid'), url = p.data('url');
                        $(document).trigger('tw-tweet', [{url: url, data: event.data, mid: mid}]);
                    });
                    window.twttr.events.bind("follow", function (event) {
                        var p = $(event.target).parent();
                        var mid = p.data('mid'), url = p.data('url');
                        $(document).trigger('tw-follow', [{url: url, data: event.data, mid: mid}]);
                    });
                }
            },
            gplus: {
                src: '//apis.google.com/js/plusone.js',
                id: 'gplus-jssdk',
                isLoaded: function() {
                    return ($.type(window.gapi) == 'object');
                },
                createButton: function(container, settings) {
                    var buttons = container.find('.ja-google-plus-button');
                    if(buttons.length) {
                        if(!this.isLoaded() && settings.loadSdk) {
                            window.___gcfg = window.___gcfg || {lang: settings.languageCode};
                            $.joomlart.socialLocker.loadScript(this.id, this.src);
                        }

                        (function(d, b, s){
                            var r = function() {
                                if(d.isLoaded()) {
                                    d._renderButton(b, s);
                                } else {
                                    setTimeout(function() {
                                        r();
                                    }, 500);
                                }
                            };
                            r();
                        })(this, buttons[0], settings);
                    }
                },
                _renderButton: function(btn, settings){
                    var d = $(btn);
                    //d.addClass('g-plusone');
                    window.gapi.plusone.render(
                        btn,
                        {
                            href: d.data('href'),
                            size: d.data('size'),
                            annotation: d.data('annotation'),
                            callback: function(params) {
                                if (params.state == "on") {
                                    $(document).trigger("gp-like", [{url:params.href, mid: settings.moduleid}]);
                                } else if (params.state == "off") {
                                    $(document).trigger("gp-dislike", [{url:params.href, mid: settings.moduleid}]);
                                }
                            }
                        }
                    );
                    $(document).trigger("gp-render", [{mid: settings.moduleid}]);
                }
            },
            linkedIn: {
                src: '//platform.linkedin.com/in.js',
                id: 'linkedin-jssdk',
                isLoaded: function() {
                    return ($.type(window.IN) == 'object');
                },
                createButton: function(container, settings) {
                    var buttons = container.find('.btn-linkedin');
                    if(buttons.length) {
                        if(!this.isLoaded() && settings.loadSdk) {
                            $.joomlart.socialLocker.loadScript(this.id, this.src);
                        }
                        (function(d, b, s){
                            var r = function() {
                                if(d.isLoaded()) {
                                    d._renderButton(b, s);
                                } else {
                                    setTimeout(function() {
                                        r();
                                    }, 500);
                                }
                            };
                            r();
                        })(this, buttons[0], settings);
                    }
                },
                _renderButton: function(btn, settings){
                    var $btn = $(btn);
                    var url = $btn.attr('data-url');
                    var dataCounter = $btn.attr('data-counter');
                    
                    //support evenName: auth, frameworkLoaded , logout , systemReady 
                    var callbackScope = ''; // default is window
                    var extraData = {url: url};
                    window.IN.Event.onOnce(IN, 'frameworkLoaded', function(event){
                        $(document).trigger("linkedin-render", [{mid: settings.moduleid}]);
                    }, callbackScope, extraData);
                    
                    $btn.append($("<script />", {
                        'data-url': url+"&mid="+settings.moduleid,
                        'data-counter': dataCounter,
                        'data-onSuccess': '$.afterLinkedInShared',
                        'data-onError': '$.afterLinkedInError',
                        'type': 'IN/Share'
                    }));
                }
            }
        },
        init: function(container, settings) {
            var config = {
                theme: 'default',
                use_ajax: 1,
                onRender: null,
                onLike: null,
                onDisLike: null
            };

            this.container = container;
            this.settings = $.extend(config, settings);
            
            //register events
            (function(t, s){
                $(document).bind('fb-render', function(params) {
                    t._handleRender('facebook', params);
                });
                $(document).bind('fb-like', function(event, params) {
                    t._handleLike('facebook', params);
                });
                $(document).bind('fb-dislike', function(event, params) {
                    t._handleDislike('facebook', params);
                });
                //
                $(document).bind('tw-render', function(params) {
                    t._handleRender('twitter', params);
                });
                $(document).bind('tw-tweet', function(event, params) {
                    t._handleLike('twitter', params);
                });
                $(document).bind('tw-follow', function(event, params) {
                    t._handleLike('twitter', params);
                });
                //
                $(document).bind('gp-render', function(params) {
                    t._handleRender('gplus', params);
                });
                $(document).bind('gp-like', function(event, params) {
                    t._handleLike('gplus', params);
                });
                $(document).bind('gp-dislike', function(event, params) {
                    t._handleDislike('gplus', params);
                });
                
                //linkedin
                $(document).bind('linkedin-render', function(event, params) {
                    t._handleRender('linkedin', params);
                });
                
            })(this, this.settings);

            this.createButtons();
            this.doLike(0);
        },
        _handleRender: function(button, params) {
            if(params.mid != this.settings.moduleid) return;

            if($.type(this.settings.onRender) == 'function') {
                this.settings.onRender(button);
            }
        },
        _handleLike: function(button, params) {
            if(params.mid != this.settings.moduleid) return;

            if($.type(params.url) != 'undefined' && params.url !== null) {
                var c = "jaslc"+button;
                var jaslc = $.cookie(c), added = 0;
                if($.type(jaslc) == 'string') jaslc = JSON.parse(jaslc);
                if(!jaslc || $.type(jaslc) != 'array') jaslc = [];

                for(i = 0; i<jaslc.length; i++) {
                    if(params.url == jaslc[i]) {
                        added = 1;
                        break;
                    }
                }
                if(!added) {
                    jaslc.push(params.url);
                }
                $.cookie(c, JSON.stringify(jaslc), {expires : 365, path: '/'});

                this.doLike(1);
            }
        },
        doLike: function(displayError) {
            if($.type(this.settings.onLike) == 'function') {
                this.settings.onLike();
                if(this.settings.hideLocker) {
                    $('#ja-locked-'+moduleid + ' .locker').css('display', 'none');
                }
            } else {
                var moduleid = this.settings.moduleid;

                if(this.settings.use_ajax) {
                    (function(s, moduleid, displayError) {
                        var data = {moduleid: moduleid, url: window.location.href};
                        $.ajax(s.baseurl + '/index.php?option=com_ajax&module=jasocial_locker&method=getContent&format=json&tmpl=component&Itemid='+JAItemid, {
                            type: 'POST',
                            data: data,
                            success: function(data){
                                if($.type(data) == 'string') {
                                    data = JSON.parse(data);
                                }

                                if(!data.success && data.message != null) {
                                    if(displayError) {
                                        alert(data.message);
                                    }
                                    return;
                                }

                                data = data.data;
                                if(!data.error) {
                                    var content = $('#ja-locked-content'+moduleid);
                                    content.html(data.content);
                                    content.removeClass('closed').addClass('opened');

                                    var locker = $('#ja-locked-'+moduleid);
                                    locker.removeClass('locked').addClass('unlocked');
                                    if(s.hideLocker) {
                                        locker.addClass('hide-locker');
                                    }
                                } else {
                                    if(displayError) {
                                        var content = $('#ja-locked-content'+moduleid);
                                        content.html(data.content);
                                        content.removeClass('closed').addClass('opened').addClass('error');
                                    }
                                }
                            }
                        });
                    })(this.settings, this.settings.moduleid, displayError);

                } else {
                    var chk = 0;
                    for(button in this.settings.urls) {
                        var c = "jaslc"+button, url = this.settings.urls[button];
                        var jaslc = $.cookie(c);
                        if($.type(jaslc) == 'string') jaslc = JSON.parse(jaslc);
                        if($.type(jaslc) == 'array') {
                            for(i = 0; i<jaslc.length; i++) {
                                if(url == jaslc[i]) {
                                    chk = 1;
                                    break;
                                } else {
                                    url = url.test(/\/$/) ? url.replace(/\/+$/g, '') : (url + '/');
                                    if(url == jaslc[i]) {
                                        chk = 1;
                                        break;
                                    }
                                }
                            }
                        }
                        if(chk) break;
                    }
                    if(chk) {
                        (function(s, moduleid, displayError) {
                            var content = $('#ja-locked-content'+moduleid);
                            content.removeClass('closed').addClass('opened');

                            var locker = $('#ja-locked-'+moduleid);
                            locker.removeClass('locked').addClass('unlocked');
                            if(s.hideLocker) {
                                locker.addClass('hide-locker');
                            }
                        })(this.settings, moduleid, displayError);
                    }
                }
            }
        },
        _handleDislike: function(button, params) {
            if(params.mid != this.settings.moduleid) return;

            if($.type(params.url) != 'undefined' && params.url !== null) {
                var c = "jaslc"+button;
                var jaslc = $.cookie(c);
                if($.type(jaslc) == 'string') jaslc = JSON.parse(jaslc);
                if($.type(jaslc) == 'array' && jaslc.length) {
                    var jaslc2 = [];
                    for(i = 0; i<jaslc.length; i++) {
                        if(params.url != jaslc[i]) {
                            jaslc2.push(jaslc[i]);
                        }
                    }
                    $.cookie(c, JSON.stringify(jaslc2), {expires : 365, path: '/'});
                }
            }

            if($.type(this.settings.onDisLike) == 'function') {
                this.settings.onDisLike(button, params);
            } else {
                var moduleid = this.settings.moduleid;
                var locker = $('#ja-locked-'+moduleid);
                locker.removeClass('unlocked').addClass('locked');

                var content = $('#ja-locked-content'+moduleid);
                content.removeClass('opened').addClass('closed');
                if(this.settings.use_ajax) {
                    content.html('');
                }
            }
        },
        loadScript: function(id, src) {
            if(!document.getElementById(id)) {
                $("body").append($("<script />", {
                    id: id,
                    src: src,
                    type: 'text/javascript'
                }));
                
                //Set language for linkedin
                if(id == 'linkedin-jssdk'){
                    if($.type(this.settings.language) != 'null') {
                        $('#'+id).append('lang: '+this.settings.language);
                    }
                }
            }
        },
        getSDK: function(name) {
            if($.type(this.sdk[name] == 'object')) {
                return this.sdk[name];
            }
            return null;
        },
        createButtons: function() {
            for (var i in this.sdk) {
                this.sdk[i].createButton(this.container, this.settings);
            }
        }
    };
})(jQuery);

(function($){
    $.fn.jaSocialLocker = function(settings){
        var sl = Object.create($.joomlart.socialLocker);
        sl.init(this, settings);
        return this;
    };
})(jQuery);

//Bellow Functions for Linkedin only
$.afterLinkedInShared = function(sharedUrl){
    if(sharedUrl.length > 0){
        var pos = sharedUrl.indexOf("&mid=");
        var moduleId = parseInt(sharedUrl.substring(pos + 5));
        sharedUrl = sharedUrl.substring(0, pos);
        
        var btn = jQuery('#btn-linkedin-'+moduleId);
        var useAjax = parseInt(btn.attr('data-use-ajax'));
        var hideLocker = parseInt(btn.attr('data-hide-locker'));
        var displayError = true;
        if(useAjax == 1){
            var data = {moduleid: moduleId, url: sharedUrl};
            var baseUrl = "";
            var ajaxUrl = baseUrl + '/index.php?option=com_ajax&module=jasocial_locker&method=getContent&format=json&tmpl=component&Itemid='+JAItemid;
            jQuery.ajax({
                type: 'POST',
                url: ajaxUrl,
                data: data,
                async: true,
                beforeSend: function(){
                    $.checkLinkedInCookie(sharedUrl);
                },
                success: function($result){
                    if(jQuery.type($result) == 'string') {
                        $result = jQuery.parseJSON($result);
                    }

                    if(!$result.success && $result.message != null) {
                        if(displayError) {
                            alert($result.message);
                        }
                        return;
                    }

                    var $data = $result.data;
                    var $content = jQuery('#ja-locked-content'+moduleId);

                    if(!$data.error) {
                        $content.html($data.content);
                        $content.removeClass('closed').addClass('opened');

                        var $locker = jQuery('#ja-locked-'+moduleId);
                        $locker.removeClass('locked').addClass('unlocked');
                        if(hideLocker ==  1) {
                            $locker.addClass('hide-locker');
                        }
                    } else {
                        if(displayError) {
                            $content.html($data.content);
                            $content.removeClass('closed').addClass('opened').addClass('error');
                        }
                    }
                }
            });
        }else{
            //check cookie
            $.checkLinkedInCookie(sharedUrl);
            
            var $content = jQuery('#ja-locked-content'+moduleId);
            $content.removeClass('closed').addClass('opened');
            var $locker = jQuery('#ja-locked-'+moduleId);
            $locker.removeClass('locked').addClass('unlocked');
            if(hideLocker == 1) {
                $locker.addClass('hide-locker');
            }
        }
    }
}
$.checkLinkedInCookie = function(sharedUrl){
    //Start process cookie
    var c = "jaslclinkedin";
    var jaslc = jQuery.cookie(c), added = 0;
    if(jQuery.type(jaslc) == 'string') jaslc = jQuery.parseJSON(jaslc);

    if(!jaslc || jQuery.type(jaslc) != 'array') jaslc = [];

    for(i = 0; i<jaslc.length; i++) {
        if(sharedUrl == jaslc[i]) {
            added = 1;
            break;
        }
    }
    if(!added) {
        jaslc.push(sharedUrl);
    }
    jQuery.cookie(c, JSON.stringify(jaslc), {expires : 365, path: '/'});
    //End process cookie
}
$.afterLinkedInError = function(error){
    alert(error);
}