<?php
/**
 * $JA#COPYRIGHT$
 */

// no direct access
defined('_JEXEC') or die('Restricted access');
class modJASocialLockerMessage
{
	protected $error = null;
	protected $content = null;

	public function __construct() {

	}

	public function send($content, $error = 0) {
		$obj = new stdClass();
		$obj->error = (int) $error;
		$obj->content = $content;

		return $obj;
	}
}

class modJASocialLockerHelper
{
	protected $cookeprefix = "jaslc";
	public $module = null;
	public $params = null;
	public $defaultUrl = '';

	public function __construct($module, $params, $defaultUrl) {
		$this->module = $module;
		$this->params = $params;
		$this->defaultUrl = preg_replace('/(\?|\&|\&amp;)jaSocialLocker.*/i', '', $defaultUrl);
	}

	public function renderButtons() {
		$module = $this->module;
		$params = $this->params;

		$langTag = JFactory::getLanguage()->getTag();
		$langCode = preg_replace('/\-.*/', '', $langTag);

		$buttons = '';

		$annotation = 'bubble';
		switch($params->get('button_style', 'standard')) {
			case 'nocounter':
				$btnFb = 'button';
				$btnTw = 'none';
				$btnGp = 'medium';
				$annotation = 'none';
                $linkedDataCounter = '';
				break;
			case 'box':
				$btnFb = 'box_count';
				$btnTw = 'vertical';
				$btnGp = 'tall';
                $linkedDataCounter = 'top';
				break;
			case 'standard':
			default:
				$btnFb = 'button_count';
				$btnTw = 'horizontal';
				$btnGp = 'medium';
                $linkedDataCounter = 'right';
				break;
		}
		if($params->get('facebook_enable', 1)) {
			$url = $params->get('facebook_url', $this->defaultUrl);
			$buttons .= '
				<div class="btn-social btn-facebook" data-mid="'.$module->id.'">
					<div class="ja-fb-like" data-href="'.$url.'" data-action="'.$params->get('facebook_action', 'like').'" data-layout="'.$btnFb.'" data-show-faces="false" data-share="false"></div>
				</div>';
		}

		if($params->get('twitter_enable', 1)) {
			$url = $params->get('twitter_url', $this->defaultUrl);
			$counturl = $params->get('twitter_counturl', $url);
			$via = trim($params->get('twitter_follower', ''));
			$via = empty($via) ? '' : 'data-related="'.$via.'"';

			$buttons .= '
				<div class="btn-social btn-twitter" data-url="'.$url.'" data-mid="'.$module->id.'">
					<a href="'.$url.'" data-url="'.$url.'" data-counturl="'.$counturl.'" class="ja-twitter-share-button" data-count="'.$btnTw.'" '.$via.' data-lang="'.$langCode.'">Tweet</a>
				</div>';
		}
		if($params->get('gplus_enable', 1)) {
			$url = $params->get('gplus_url', $this->defaultUrl);
			$buttons .= '
				<div class="btn-social btn-gplus">
					<div data-href="'.$url.'" class="ja-google-plus-button" data-size="'.$btnGp.'" data-annotation="'.$annotation.'"></div>
				</div>';
		}
        
        if($params->get('linkedin_enable', 1)) {
			$url = $params->get('linkedin_url', $this->defaultUrl);
            $useAjax = (int) $params->get('use_ajax', 1);
            if(!JFile::exists(JPATH_ROOT.'/components/com_ajax/ajax.php')) {
                //disable use ajax if com_ajax is not installed
                $useAjax = 0;
            }
            $hideLocker = (int) $params->get('hide_when_done', 0);
			$buttons .= ' <div id="btn-linkedin-'.$module->id.'" 
                              class="btn-social btn-linkedin" 
                              data-hide-locker ="'.$hideLocker.'" 
                              data-use-ajax ="'.$useAjax.'" 
                              data-counter="'.$linkedDataCounter.'" 
                              data-url="'.$url.'" data-mid="'.$module->id.'">
                         </div>';
		}

		return $buttons;
	}

	public function getTweets() {
		$params = $this->params;
		$tweets = array();
		$tweet = $params->get('twitter_content', '');
		if(!empty($tweet)) {
			$tweet = trim(preg_replace('/[\r\n]+/', "\n", $tweet));
			$tweets = preg_split('/\n/', $tweet);
		}
		return $tweets;
	}

	public static function getContentAjax() {
		// Get module parameters
		jimport('joomla.application.module.helper');

		//load language
		$lang = JFactory::getLanguage();
		$lang->load('mod_jasocial_locker');

		$app 			= JFactory::getApplication();
		$msg 			= new modJASocialLockerMessage();

		$moduleid 		= $app->input->getInt('moduleid', 0);
		$currentUrl 	= @$_POST['url'];

		if(!$moduleid && empty($currentUrl)) {
			return $msg->send(JText::_('MSG_INVALID_REQUEST'), 1);
		}

		//anti fake request to get locked content
		$referer = @$_SERVER['HTTP_REFERER'];
		if(!$referer || strpos($referer, JUri::base()) !== 0) {
			return $msg->send(JText::_('MSG_INVALID_REQUEST'), 1);
		}

		$db = JFactory::getDbo();
		$query = $db->getQuery(true);
		$query->select('*')->from('#__modules')->where($db->quoteName('id').'='.$moduleid);
		$db->setQuery($query);
		$module = $db->loadObject();

		if(!$module->id) {
			return $msg->send(JText::_('MSG_INVALID_REQUEST'), 1);
		}

		$params = new JRegistry();
		$params->loadString($module->params);

		$obj = new modJASocialLockerHelper($module, $params, $currentUrl);
		$unlocked = $obj->isUnlocked();

		if(!$unlocked) {
			return $msg->send(JText::_('MSG_CONTENT_IS_NOT_UNLOCKED'), 2);
		}
		$content = $params->get('locked_content', '');
		$content = $obj->updateLinks($content);
		return $msg->send($content);
	}

	public function isUnlocked() {
		$unlocked = $this->isLiked();
		if(!$unlocked) {
			//check if user in user group which can view locked content
			$unlock_groups = $this->params->get('unlock_groups', array());
			if(!is_array($unlock_groups)) {
				$unlock_groups = array($unlock_groups);
			}
			if(count($unlock_groups)) {
				$user = JFactory::getUser();
				$groups = array_intersect($user->getAuthorisedGroups(), $unlock_groups);
				if(count($groups)) {
					$unlocked = 1;
				}
			}
		}
		return $unlocked;
	}

	public function isLiked() {
		return ($this->isFbLiked() || $this->isTweeted() || $this->isGplusLiked() || $this->isLinkedInShared());
	}

	public function isFbLiked() {
		$url = $this->params->get('facebook_url', $this->defaultUrl);
		return $this->isShared('facebook', $url);
	}

	public function isTweeted() {
		$url = $this->params->get('twitter_url', $this->defaultUrl);
		return $this->isShared('twitter', $url);
	}

	public function isGplusLiked() {
		$url = $this->params->get('gplus_url', $this->defaultUrl);
		return $this->isShared('gplus', $url);
	}
    
    public function isLinkedInShared(){
        $url = $this->params->get('linkedin_url', $this->defaultUrl);
		return $this->isShared('linkedin', $url);
    }

	private function isShared($network, $url) {
		$cookie = $this->getCookie($network);
		$result = false;
		if(is_array($cookie) && count($cookie)) {
			$result = in_array($url, $cookie);
			if(!$result) {
				//try
				if(preg_match('/\/$/', $url)) {
					$url = preg_replace('/\/$/', '', $url);
				} else {
					$url .= '/';
				}
				$result = in_array($url, $cookie);
			}
		}
		return $result;

	}

	private function getCookie($cname) {
		$cname = $this->cookeprefix . $cname;
		$cookie = array();
		if(isset($_COOKIE[$cname])) {
			$cookie = json_decode($_COOKIE[$cname]);
		}
		return $cookie;
	}

	/**
	 * @see PlgSystemSef
	 * @param $buffer
	 * @return mixed
	 */
	public function updateLinks($buffer) {
		// Replace src links.
		$base   = JUri::base(true).'/';

		$regex  = '#href="index.php\?([^"]*)#m';
		$buffer = preg_replace_callback($regex, array($this, 'route'), $buffer);
		$this->checkBuffer($buffer);

		// Check for all unknown protocals (a protocol must contain at least one alpahnumeric character followed by a ":").
		$protocols = '[a-zA-Z0-9]+:';
		$regex     = '#(src|href|poster)="(?!/|' . $protocols . '|\#|\')([^"]*)"#m';
		$buffer    = preg_replace($regex, "$1=\"$base\$2\"", $buffer);
		$this->checkBuffer($buffer);

		$regex  = '#(onclick="window.open\(\')(?!/|' . $protocols . '|\#)([^/]+[^\']*?\')#m';
		$buffer = preg_replace($regex, '$1' . $base . '$2', $buffer);
		$this->checkBuffer($buffer);

		// ONMOUSEOVER / ONMOUSEOUT
		$regex  = '#(onmouseover|onmouseout)="this.src=([\']+)(?!/|' . $protocols . '|\#|\')([^"]+)"#m';
		$buffer = preg_replace($regex, '$1="this.src=$2' . $base .'$3$4"', $buffer);
		$this->checkBuffer($buffer);

		// Background image.
		$regex  = '#style\s*=\s*[\'\"](.*):\s*url\s*\([\'\"]?(?!/|' . $protocols . '|\#)([^\)\'\"]+)[\'\"]?\)#m';
		$buffer = preg_replace($regex, 'style="$1: url(\'' . $base .'$2$3\')', $buffer);
		$this->checkBuffer($buffer);

		// OBJECT <param name="xx", value="yy"> -- fix it only inside the <param> tag.
		$regex  = '#(<param\s+)name\s*=\s*"(movie|src|url)"[^>]\s*value\s*=\s*"(?!/|' . $protocols . '|\#|\')([^"]*)"#m';
		$buffer = preg_replace($regex, '$1name="$2" value="' . $base . '$3"', $buffer);
		$this->checkBuffer($buffer);

		// OBJECT <param value="xx", name="yy"> -- fix it only inside the <param> tag.
		$regex  = '#(<param\s+[^>]*)value\s*=\s*"(?!/|' . $protocols . '|\#|\')([^"]*)"\s*name\s*=\s*"(movie|src|url)"#m';
		$buffer = preg_replace($regex, '<param value="' . $base .'$2" name="$3"', $buffer);
		$this->checkBuffer($buffer);

		// OBJECT data="xx" attribute -- fix it only in the object tag.
		$regex  = '#(<object\s+[^>]*)data\s*=\s*"(?!/|' . $protocols . '|\#|\')([^"]*)"#m';
		$buffer = preg_replace($regex, '$1data="' . $base . '$2"$3', $buffer);
		$this->checkBuffer($buffer);

		return $buffer;
	}

	/**
	 * Check the buffer.
	 *
	 * @param   string  $buffer  Buffer to be checked.
	 *
	 * @return  void
	 */
	private function checkBuffer($buffer)
	{
		if ($buffer === null)
		{
			switch (preg_last_error())
			{
				case PREG_BACKTRACK_LIMIT_ERROR:
					$message = "PHP regular expression limit reached (pcre.backtrack_limit)";
					break;
				case PREG_RECURSION_LIMIT_ERROR:
					$message = "PHP regular expression limit reached (pcre.recursion_limit)";
					break;
				case PREG_BAD_UTF8_ERROR:
					$message = "Bad UTF8 passed to PCRE function";
					break;
				default:
					$message = "Unknown PCRE error calling PCRE function";
			}
			throw new RuntimeException($message);
		}
	}

	/**
	 * Replace the matched tags.
	 *
	 * @param   array  &$matches  An array of matches (see preg_match_all).
	 *
	 * @return  string
	 */
	protected static function route(&$matches)
	{
		$url   = $matches[1];
		$url   = str_replace('&amp;', '&', $url);
		$route = JRoute::_('index.php?'.$url);

		return 'href="' . $route;
	}
}